-----------------------------------------------------------------------------------------------
-- Client Lua Script for AreYouAWerewolf
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------
 
require "Window"
require "ChatSystemLib"
 
-----------------------------------------------------------------------------------------------
-- AreYouAWerewolf Module Definition
-----------------------------------------------------------------------------------------------
local AreYouAWerewolf = {} 
 
-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
-- e.g. local kiExampleVariableMax = 999
 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------

local Players = {}
local Rolls = {}
local PlayersNew = {}
local Phase = "off"
local Status={}

function AreYouAWerewolf:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here

    return o
end

function AreYouAWerewolf:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		-- "UnitOrPackageName",
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 

-----------------------------------------------------------------------------------------------
-- AreYouAWerewolf OnLoad
-----------------------------------------------------------------------------------------------
function AreYouAWerewolf:OnLoad()
    -- load our form file
	self.xmlDoc = XmlDoc.CreateFromFile("AreYouAWerewolf.xml")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
end

-----------------------------------------------------------------------------------------------
-- AreYouAWerewolf OnDocLoaded
-----------------------------------------------------------------------------------------------
function AreYouAWerewolf:OnDocLoaded()

	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	    self.wndMain = Apollo.LoadForm(self.xmlDoc, "AreYouAWerewolfForm", nil, self)
		if self.wndMain == nil then
			Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
			return
		end
		
	    self.wndMain:Show(false, true)
	
		Apollo.RegisterEventHandler("ChatMessage", "OnChatMessage", self)
		--Apollo.RegisterSlashCommand("wwRegister", "OnRegisterNames", self)
		--Apollo.RegisterSlashCommand("wwRegister", "OnRegisterNames", self)

		-- if the xmlDoc is no longer needed, you should set it to nil
		-- self.xmlDoc = nil
		
		-- Register handlers for events, slash commands and timer, etc.
		-- e.g. Apollo.RegisterEventHandler("KeyDown", "OnKeyDown", self)


		-- Do additional Addon initialization here
	end
end

-----------------------------------------------------------------------------------------------
-- AreYouAWerewolf Functions

function AreYouAWerewolf:OnRegisterName(Name)
	Count = 0
	if Players[0] ~= nil then
		for Index, Value in pairs( Players ) do
  			Count = Count + 1
		end
	end
	ChatSystemLib.Command(string.format("/s Registering " .. Name .. " Total of " .. Count+1 .. " Players" ))
	Players[Count] = Name
	Rolls[Count] = "Unset"
	Status[Count] = "Alive"
end

function AreYouAWerewolf:OnUnRegisterName(Name)
	ChatSystemLib.Command(string.format("/s Unregistering " .. Name ))
	local i=0
	for x=0, table.getn(Players) do
		if Players[x]~=Name then
			PlayersNew[i] = Players[x]
			i=i+1
		end
	end
	Players={}
	Players=PlayersNew
end

function AreYouAWerewolf:OnList(Sender)
	if Players[0] ~= nil then
		for x=0, table.getn(Players) do
			ChatSystemLib.Command(string.format("/w " .. Sender .. " [ " ..Players[x] .. " ][ " .. Status[x] .. " ]"))
		end
	else
		ChatSystemLib.Command(string.format("/w " .. Sender .. " Nobody in list"))
	end
end

function AreYouAWerewolf:OnIdentify(Sender)
	if Players[0] ~= nil then
		for x=0, table.getn(Players) do
			ChatSystemLib.Command(string.format("/w " .. Sender .. " [ " ..Players[x] .. " ][ " .. Rolls[x] .. " ][ " .. Status[x] .. " ]"))
		end
	else
		ChatSystemLib.Command(string.format("/w " .. Sender .. " Nobody in list"))
	end
end

function AreYouAWerewolf:OnReset()
	ChatSystemLib.Command(string.format("/s Resetting" ))
	Players={}
	Rolls={}
	Phase=Off
end

function AreYouAWerewolf:OnStartGame(HostName)
	ChatSystemLib.Command(string.format("/s Starting" ))
	local Count=0
	if Players[0] ~= nil then
		for Index, Value in pairs( Players ) do
  			Count = Count + 1
		end
		if Count>4 then
			local WerewolfCount=math.floor(Count/4)
			local VillagerCount=Count-WerewolfCount
			ChatSystemLib.Command(string.format("/s " .. VillagerCount .. " / " .. WerewolfCount))
			for x=0,WerewolfCount-1 do
				local itisset=0
				while itisset==0 do
					local rnd=math.random(Count)
					--ChatSystemLib.Command(string.format("/s Testing " .. rnd))
					if Rolls[rnd]=="Unset" then
						Rolls[rnd]="WereWolf"
						ChatSystemLib.Command(string.format("/w " .. Players[rnd] .. " You're a Werewolf "))
						ChatSystemLib.Command(string.format("/w " .. HostName .. " " .. Players[rnd] .. " is a Werewolf "))
						itisset=1
					else
						--ChatSystemLib.Command(string.format("/s Not Valid... " .. rnd))
					end
				end
			end
			for y=0, Count-1 do
				if Rolls[y]=="Unset" then
					Rolls[y]="Villager"
					ChatSystemLib.Command(string.format("/w " .. Players[y] .. " You're a Villager "))
				end
			end
			Phase=1
			AreYouAWerewolf:OnNext()
		else
		 ChatSystemLib.Command(string.format("/s Not Enough Players, Minimum 5 "))
		end
	else
		ChatSystemLib.Command(string.format("/s No Players Registered " ))
	end
	
end

function AreYouAWerewolf:OnNext()
	if Phase~="off" then
		if Phase==1 then
			Phase=2
			ChatSystemLib.Command(string.format("/s Good morning everybody! OH NO! What has happened? Your beautiful georgous sexy mayor... HAS DIED! He/ or she... has been Chewed up and clawed to death by what appears to be Werewolfs! Because.. ofcourse, Werewolves exist! What to do... Oh BLAME SOMEONE!" ))
		elseif Phase==2 then
			Phase=3
			ChatSystemLib.Command(string.format("/s Alright you all goto bed. Werewolves now have a chace to pick a new target to kill. (Whisper between the two of you and figure it out. then tell the Host who it is you choose.)" ))
		elseif Phase==3 then
			Phase=2
			ChatSystemLib.Command(string.format("/s Good morning everybody! You guessed it... Someone DIED! Start the blamegame again!" ))
		end		
	end
end

function AreYouAWerewolf:OnKill(Name)
	local Count=0
	if Players[0] ~= nil then
		for Index, Value in pairs( Players ) do
  			Count = Count + 1
		end
		for x=0, Count do
			--ChatSystemLib.Command(string.format("/s " .. Name .. " / " .. Players[x] .. "" ))
			if Players[x]==Name then
				Status[x]="Dead"
				ChatSystemLib.Command(string.format("/s " .. Name .. " Has died!" ))
			end
		end
	end
end
function AreYouAWerewolf:OnResurrect(Name)
	local Count=0
	if Players[0] ~= nil then
		for Index, Value in pairs( Players ) do
  			Count = Count + 1
		end
		for x=0, Count-1 do
			if Players[x]==Name then
				Status[x]="Alive"
				ChatSystemLib.Command(string.format("/s " .. Name .. " Has Risen!" ))
			end
		end
	end
end
function AreYouAWerewolf:OnClear()
	Phase="off"
	local Count=0
	if Players[0] ~= nil then
		for Index, Value in pairs( Players ) do
  			Count = Count + 1
		end
		for x=0, Count-1 do
			Rolls[x]="Unset"
			Status[x]="Alive"
		end
	end
end
function AreYouAWerewolf:OnWhoAmI(Sender)
	Phase="off"
	local Count=0
	if Players[0] ~= nil then
		for Index, Value in pairs( Players ) do
  			Count = Count + 1
		end
		for x=0, Count-1 do
			if Players[x]==Sender then
				ChatSystemLib.Command(string.format("/w " .. Sender .. " You are a " .. Rolls[x] ))
			end
		end
	end
end


-----------------------------------------------------------------------------------------------
-- Define general functions here

function AreYouAWerewolf:OnChatMessage(channelCurrent, tMessage)
	if channelCurrent:GetType() == ChatSystemLib.ChatChannel_Whisper then
		local Sender = ""
		local Message = ""
		local drPlayer = GameLib.GetPlayerUnit()
		local HostName = drPlayer and drPlayer:GetName() or "player"
		local MessageParts = {}
		for _,v in ipairs(tMessage.arMessageSegments) do
			Message = v.strText
			Sender = tMessage.strSender
		end
		local x=0
		for token in string.gmatch(Message, "[^%s]+") do
	  		MessageParts[x] = token
			x=x+1
		end
		if Sender == HostName then
			if MessageParts[0] == "WWRegister" then
				AreYouAWerewolf:OnRegisterName(MessageParts[1])
			elseif MessageParts[0] == "WWUnRegister" then
				AreYouAWerewolf:OnUnRegisterName(MessageParts[1])
			elseif MessageParts[0] == "WWIdentify" then
				AreYouAWerewolf:OnIdentify(HostName)
			elseif MessageParts[0] == "WWReset" then
				AreYouAWerewolf:OnReset()
			elseif MessageParts[0] == "WWStart" then
				AreYouAWerewolf:OnStartGame(HostName)
			elseif MessageParts[0] == "WWNext" then
				AreYouAWerewolf:OnNext()
			elseif MessageParts[0] == "WWClear" then
				AreYouAWerewolf:OnClear()
			elseif MessageParts[0] == "WWKill" then
				AreYouAWerewolf:OnKill(MessageParts[1])
			elseif MessageParts[0] == "WWResurrect" then
				AreYouAWerewolf:OnResurrect(MessageParts[1])
			end
		end
		if MessageParts[0] == "WWList" then
			AreYouAWerewolf:OnList(Sender)
		elseif MessageParts[0] == "WWWhoAmI" then
			AreYouAWerewolf:OnWhoAmI(Sender)
		end
--		ChatSystemLib.Command(string.format("/s Whisper Rcieved[ " .. Sender .. ": " ..MessageParts[0] .. " ]"))
	end
end

-----------------------------------------------------------------------------------------------
-- AreYouAWerewolfForm Functions
-----------------------------------------------------------------------------------------------
-- when the OK button is clicked
function AreYouAWerewolf:OnOK()
	self.wndMain:Close() -- hide the window
end

-- when the Cancel button is clicked
function AreYouAWerewolf:OnCancel()
	self.wndMain:Close() -- hide the window
end


-----------------------------------------------------------------------------------------------
-- AreYouAWerewolf Instance
-----------------------------------------------------------------------------------------------
local AreYouAWerewolfInst = AreYouAWerewolf:new()
AreYouAWerewolfInst:Init()
